unit heureparle_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, process, FileUtil, UTF8Process, Forms, Controls, Graphics,
  Dialogs, ExtCtrls, StdCtrls, Menus, Buttons, ComObj;

const
  Col_Vert_ = $00A6FFA6;
  Col_Orange_ = $000080FF;
  Col_Bleu_ = $00E69B00;
  Col_Rose_ = $00B462F0;
  Col_Aig_ = $00F480C9;
  Col_Fond_ = $00F5DBC2;

type

  { TWdMain }

  TWdMain = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    EdDate: TEdit;
    EdHeure: TEdit;
    EdVox: TEdit;
    EdMinutes: TEdit;
    EdSecondes: TEdit;
    GroupBox1: TGroupBox;
    Img1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    SpeedButton2: TSpeedButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;

implementation

{$R *.lfm}

{ TWdMain }

var
  Minutes: array[0..100, 1..2] of real;
  Heu: array[0..11, 1..4, 1..2] of real;
  Min: array[0..59, 1..6, 1..2] of real;
  Sec: array[0..59, 1..8, 1..2] of real;
  Vox: variant;
  He: array[0..23] of variant;
  Mn: array[0..59] of variant;
  Heure, Minute: word;
  Seconde, MilliSec: word;
  MemHeu, MemMin, MemSec: word;

function RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

//procedure Msg(s: string);
//begin
//WdMain.Memo1.Lines.Add(s);
//end;

procedure TWdMain.FormDestroy(Sender: TObject);
begin
  //Désassigne une valeur vierge à la variable de type variant
  Vox := Unassigned;
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
var
  s: variant;
begin
  s := EdVox.Text;
  Vox.Speak(s);
end;

procedure Init;
begin
  //Heures
  He[0] := 'minuit';
  He[1] := 'une heure';
  He[2] := 'deux heure';
  He[3] := 'trois heure';
  He[4] := 'quatre heure';
  He[5] := 'cinq heure';
  He[6] := 'six heure';
  He[7] := 'sept heure';
  He[8] := 'huit heure';
  He[9] := 'neuf heure';
  He[10] := 'dix heure';
  He[11] := 'onze heure';
  He[12] := 'douze heure';
  He[13] := 'treize heure';
  He[14] := 'quatorze heure';
  He[15] := 'quinze heure';
  He[16] := 'seize heure';
  He[17] := 'dix sept heure';
  He[18] := 'dix huit heure';
  He[19] := 'dix neuf heure';
  He[20] := 'vinte heure';
  He[21] := 'vinte et une heure';
  He[22] := 'vinte deux heure';
  He[23] := 'vinte trois heure';
  //-
  //Minutes
  Mn[0] := 'zéro minute';
  Mn[1] := 'une minute';
  Mn[2] := 'deux minutes';
  Mn[3] := 'trois minute';
  Mn[4] := 'quatre minute';
  Mn[5] := 'cinq minute';
  Mn[6] := 'six minute';
  Mn[7] := 'sept minute';
  Mn[8] := 'huit minute';
  Mn[9] := 'neuf  minute';
  Mn[10] := 'dix minute';
  Mn[11] := 'onze minute';
  Mn[12] := 'douze minute';
  Mn[13] := 'treize minute';
  Mn[14] := 'quatorze minute';
  Mn[15] := 'quinze minute';
  Mn[16] := 'seize minute';
  Mn[17] := 'dix sept minute';
  Mn[18] := 'dix huit minute';
  Mn[19] := 'dix neuf minute';
  Mn[20] := 'vingt minute';
  Mn[21] := 'vingt et une minute';
  Mn[22] := 'vingt deux minutes';
  Mn[23] := 'vingt trois minute';
  Mn[24] := 'vingt quatre minute';
  Mn[25] := 'vingt cinq minute';
  Mn[26] := 'vingt six minute';
  Mn[27] := 'vingt sept minute';
  Mn[28] := 'vingt huit minute';
  Mn[29] := 'vingt neuf  minute';
  Mn[30] := 'trente minute';
  Mn[31] := 'trente et une minute';
  Mn[32] := 'trente deux minute';
  Mn[33] := 'trente trois minute';
  Mn[34] := 'trente quatre minute';
  Mn[35] := 'trente cinq minute';
  Mn[36] := 'trente six minute';
  Mn[37] := 'trente sept minute';
  Mn[38] := 'trente huit minute';
  Mn[39] := 'trente neuf minute';
  Mn[40] := 'quarante minute';
  Mn[41] := 'quarante et une minute';
  Mn[42] := 'quarante deux minute';
  Mn[43] := 'quarante trois minute';
  Mn[44] := 'quarante quatre minute';
  Mn[45] := 'quarante cinq minute';
  Mn[46] := 'quarante six minute';
  Mn[47] := 'quarante sept minute';
  Mn[48] := 'quarante huit minute';
  Mn[49] := 'quarante neuf minute';
  Mn[50] := 'cinquante minute';
  Mn[51] := 'cinquante et une minute';
  Mn[52] := 'cinquante deux minute';
  Mn[53] := 'cinquante trois minute';
  Mn[54] := 'cinquante quatre minute';
  Mn[55] := 'cinquante cinq minute';
  Mn[56] := 'cinquante six minute';
  Mn[57] := 'cinquante sept minute';
  Mn[58] := 'cinquante huit minute';
  Mn[59] := 'cinquante neuf minute';
end;

procedure Affiche_Cadran;
var
  n, x1, y1, x2, y2: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    n := 0;
    repeat
      case n of
        0, 15, 30, 45:
        begin
          x1 := Round(Minutes[n, 1] - 8);
          y1 := Round(Minutes[n, 2] - 8);
          x2 := Round(Minutes[n, 1] + 8);
          y2 := Round(Minutes[n, 2] + 8);
          Brush.Color := Col_Orange_;
          Rectangle(x1, y1, x2, y2);
        end;
        5, 10, 20, 25, 35, 40, 50, 55:
        begin
          x1 := Round(Minutes[n, 1] - 5);
          y1 := Round(Minutes[n, 2] - 5);
          x2 := Round(Minutes[n, 1] + 5);
          y2 := Round(Minutes[n, 2] + 5);
          Brush.Color := Col_Bleu_;
          Rectangle(x1, y1, x2, y2);
        end;
      end;
      Inc(n, 5)
    until n > 55;
  end;
end;

procedure Aff_Heures(h: integer; Col: TColor);
var
  n, x, y: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    //Affiche centre
    Brush.Color := ClBlue;
    Rectangle(140, 140, 160, 160);
    //Affiche heure
    for n := 1 to 4 do
    begin
      Brush.Color := Col;
      x := Round(Heu[h, n, 1]);
      y := Round(Heu[h, n, 2]);
      Rectangle(x - 6, y - 6, x + 6, y + 6);
    end;
  end;
end;

procedure Aff_Minutes(m: integer; Col: TColor);
var
  n, x, y: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    for n := 1 to 6 do
    begin
      Brush.Color := Col;
      x := Round(Min[m, n, 1]);
      y := Round(Min[m, n, 2]);
      Rectangle(x - 6, y - 6, x + 6, y + 6);
    end;
  end;
end;

procedure Aff_Secondes(s: integer; Col1, Col2: TColor);
var
  n, x, y: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    for n := 1 to 8 do
    begin
      Brush.Color := Col1;
      x := Round(Sec[s, n, 1]);
      y := Round(Sec[s, n, 2]);
      case n of
        1..6, 8: Rectangle(x - 6, y - 6, x + 6, y + 6);
        7:
        begin
          Brush.Color := Col2;
          Ellipse(x - 12, y - 12, x + 12, y + 12);
        end;
      end;
    end;
  end;
end;

procedure Init_Graphe;
var
  k, xr, yr: real;
  MaxX, MaxY: integer;
  DeltaX, DeltaY: integer;
  h, m, n, p, x, y: integer;
begin
  with WdMain do
  begin
    MaxX := Img1.Width;
    MaxY := Img1.Height;
    with Img1.Canvas do
    begin
      //Clear
      Pen.Color := ClCream;
      for n := 0 to MaxX do
        Line(n, 0, n, MaxY);
      //Centre 150,150
      Brush.Color := ClBlue;
      Rectangle(140, 140, 160, 160);
      //-
      //----- Création Horloge -----
      //-
      //Récup. positions et affichage des minutes
      k := 9.44;
      //k:=11.01;
      n := 0;
      repeat
        xr := 150 + 120 * sin(k);
        yr := 150 + 120 * cos(k);
        Minutes[n, 1] := xr;
        Minutes[n, 2] := yr;
        Rectangle(Round(xr - 2), Round(yr - 2), Round(xr + 2), Round(yr + 2));
        k := k - 0.1045;
        Inc(n);
      until k < 3.24;
      //-
      //----- Aiguilles -----
      //-
      //Récup. aiguilles des Heures à partir des Minutes
      //Centre : 150,150
      for h := 0 to 11 do
      begin
        //Centre
        x := 150;
        y := 150;
        //-
        m := h * 5;
        DeltaX := Round(Abs(x - Minutes[m, 1]) / 11);
        DeltaY := Round(Abs(y - Minutes[m, 2]) / 11);
        n := 1;
        p := 0;
        //-
        repeat
          if n > 1 then
          begin
            //Brush.Color := Col_Orange_;
            //Rectangle(x-6,y-6,x+6,y+6);
            Inc(p);
            if p in [1..4] then
            begin
              Heu[h, p, 1] := x;
              Heu[h, p, 2] := y;
            end;
          end;
          case m of
            0, 5, 10, 15:
            begin
              Inc(x, DeltaX);
              Dec(y, DeltaY);
            end;
            20, 25, 30:
            begin
              Inc(x, DeltaX);
              Inc(y, DeltaY);
            end;
            35, 40, 45:
            begin
              Dec(x, DeltaX);
              Inc(y, DeltaY);
            end;
            50, 55:
            begin
              Dec(x, DeltaX);
              Dec(y, DeltaY);
            end;
          end;
          Inc(n);
        until n > 5;
      end;
      //-
      //Récup. aiguille des Minutes à partir des Minutes
      //Centre : 150,150
      for m := 0 to 59 do
      begin
        //Centre
        x := 150;
        y := 150;
        //-
        DeltaX := Round(Abs(x - Minutes[m, 1]) / 11);
        DeltaY := Round(Abs(y - Minutes[m, 2]) / 11);
        n := 1;
        p := 0;
        //-
        repeat
          if n > 1 then
          begin
            //Brush.Color := Col_Bleu_;
            //Rectangle(x-6,y-6,x+6,y+6);
            Inc(p);
            if p in [1..6] then
            begin
              Min[m, p, 1] := x;
              Min[m, p, 2] := y;
            end;
          end;
          case m of
            0..15:
            begin
              Inc(x, DeltaX);
              Dec(y, DeltaY);
            end;
            16..30:
            begin
              Inc(x, DeltaX);
              Inc(y, DeltaY);
            end;
            31..45:
            begin
              Dec(x, DeltaX);
              Inc(y, DeltaY);
            end;
            46..59:
            begin
              Dec(x, DeltaX);
              Dec(y, DeltaY);
            end;
          end;
          Inc(n);
        until n > 7;
      end;
      //-
      //Récup. aiguille des Secondes à partir des Minutes
      //Centre : 150,150
      for m := 0 to 59 do
      begin
        //Centre
        x := 150;
        y := 150;
        //-
        DeltaX := Round(Abs(x - Minutes[m, 1]) / 11);
        DeltaY := Round(Abs(y - Minutes[m, 2]) / 11);
        n := 1;
        p := 0;
        //-
        repeat
          if n > 1 then
          begin
            //Brush.Color := Col_Bleu_;
            //Rectangle(x-6,y-6,x+6,y+6);
            Inc(p);
            if p in [1..8] then
            begin
              Sec[m, p, 1] := x;
              Sec[m, p, 2] := y;
            end;
          end;
          case m of
            0..15:
            begin
              Inc(x, DeltaX);
              Dec(y, DeltaY);
            end;
            16..30:
            begin
              Inc(x, DeltaX);
              Inc(y, DeltaY);
            end;
            31..45:
            begin
              Dec(x, DeltaX);
              Inc(y, DeltaY);
            end;
            46..59:
            begin
              Dec(x, DeltaX);
              Dec(y, DeltaY);
            end;
          end;
          Inc(n);
        until n > 9;
      end;
      //-
      //Affiche Cadran des Heures et Minutes
      Affiche_Cadran;
    end;
  end;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
var
  HMSM: TTime;
begin
  Aff_Heures(MemHeu, ClWhite);
  Aff_Minutes(MemMin, ClWhite);
  Aff_Secondes(MemSec, ClWhite, ClWhite);
  //-
  HMSM := Now;
  DecodeTime(HMSM, Heure, Minute, Seconde, MilliSec);
  EdDate.Text := DateToStr(Now);
  EdHeure.Text := IntToStr(Heure);
  EdMinutes.Text := IntToStr(Minute);
  EdSecondes.Text := IntToStr(Seconde);
  //-
  if Seconde = 1 then
  begin
    //Heures
    if CheckBox1.Checked then
      Vox.Speak(He[Heure]);
    //Secondes
    if CheckBox2.Checked then
      Vox.Speak(Mn[Minute]);
  end;
  //-
  if Heure > 11 then
    Heure := Heure - 12;
  //-
  MemHeu := Heure;
  MemMin := Minute;
  MemSec := Seconde;
  //-
  Aff_Heures(Heure, Col_Orange_);
  Aff_Minutes(Minute, Col_Bleu_);
  Aff_Secondes(Seconde, Col_Rose_, Col_Aig_);
end;

procedure TWdMain.FormCreate(Sender: TObject);
begin
  //Crée un objet unique non initialisé de la classe
  //spécifiée par le paramètre 'SAPI.SpVoice'
  Vox := CreateOLEObject('SAPI.SpVoice');
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  Init;
  Init_Graphe;
  DecodeTime(Now, Heure, Minute, Seconde, MilliSec);
  if Heure > 11 then
    Heure := Heure - 12;
  MemHeu := Heure;
  MemMin := Minute;
  MemSec := Seconde;
  ActiveControl := EdVox;
  Timer1.Enabled := True;
end;

end.
